Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 23394)
@@ -766,5 +766,29 @@
 	if(isFS){
 		iomodel->FetchDataToInput(elements,"md.initialization.pressure",PressureEnum,0.);
-		iomodel->FetchDataToInput(elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum,0.);
+
+		/*Add basal forcings to compute melt rate*/
+		int basalforcing_model;
+		iomodel->FindConstant(&basalforcing_model,"md.basalforcings.model");
+		switch(basalforcing_model){
+			case FloatingMeltRateEnum:
+				iomodel->FetchDataToInput(elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum);
+				break;
+			case LinearFloatingMeltRateEnum:
+				break;
+			case MismipFloatingMeltRateEnum:
+				break;
+			case MantlePlumeGeothermalFluxEnum:
+				break;
+			case SpatialLinearFloatingMeltRateEnum:
+				iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_melting_rate",BasalforcingsDeepwaterMeltingRateEnum);
+				iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_elevation",BasalforcingsDeepwaterElevationEnum);
+				iomodel->FetchDataToInput(elements,"md.basalforcings.upperwater_elevation",BasalforcingsUpperwaterElevationEnum);
+				break;
+			case BasalforcingsPicoEnum:
+				iomodel->FetchDataToInput(elements,"md.basalforcings.basin_id",BasalforcingsPicoBasinIdEnum);
+				break;
+			default:
+				_error_("Basal forcing model "<<EnumToStringx(basalforcing_model)<<" not supported yet");
+		}
 	}
 	/*LATH parameters*/
@@ -844,4 +868,6 @@
 			iomodel->FetchDataToInput(elements,"md.friction.till_friction_angle",FrictionTillFrictionAngleEnum);
 			iomodel->FetchDataToInput(elements,"md.friction.sediment_compressibility_coefficient",FrictionSedimentCompressibilityCoefficientEnum);
+			iomodel->FetchDataToInput(elements,"md.hydrology.watercolumn_max",HydrologyWatercolumnMaxEnum);
+			iomodel->FetchDataToInput(elements,"md.initialization.watercolumn",WatercolumnEnum,0.);
 			break;
 		default:
@@ -945,7 +971,9 @@
 		int solver_type;
 		PetscOptionsDetermineSolverType(&solver_type);
+
 		if(solver_type==FSSolverEnum) is_schur_cg_solver = true;
 		#endif
 
+		
 		if(is_schur_cg_solver)
 		 solutionsequence_schurcg(femmodel);
@@ -3270,13 +3298,12 @@
 		element->NodalFunctionsPressure(pbasis,gauss);
 
-		if(dim==3){
+		if(dim==3 || dim==2){
 			/*Pressure mass matrix*/
 			for(int k=0;k<pnumnodes;k++){
 				for(int j=0;j<pnumnodes;j++){
-					Ke->values[(3*vnumnodes+k)*numdof+3*vnumnodes+j] += gauss->weight*Jdet*(pbasis[j]*pbasis[k]);
+					Ke->values[(dim*vnumnodes+k)*numdof+dim*vnumnodes+j] += gauss->weight*Jdet*(pbasis[j]*pbasis[k]);
 				}
 			}
-		}
-		else{
+		}else{
 			_error_("STOP");
 		}
@@ -3289,4 +3316,61 @@
 	return Ke;
 }/*}}}*/
+ElementMatrix* StressbalanceAnalysis::CreateSchurPrecondMatrix(Element* element){/*{{{*/
+
+	/*Intermediaries*/
+	int         i,dim;
+	IssmDouble  viscosity,FSreconditioning,Jdet;
+	IssmDouble *xyz_list = NULL;
+
+	/*Get problem dimension*/
+	element->FindParam(&dim,DomainDimensionEnum);
+
+	/*Fetch number of nodes and dof for this finite element*/
+	int vnumnodes = element->NumberofNodesVelocity();
+	int pnumnodes = element->NumberofNodesPressure();
+	int numdof    = vnumnodes*dim + pnumnodes;
+
+	/*Initialize Element matrix and vectors*/
+	ElementMatrix* Ke  = element->NewElementMatrix(FSvelocityEnum);
+	IssmDouble* pbasis = xNew<IssmDouble>(pnumnodes);
+
+	/*Retrieve all inputs and parameters*/
+	element->GetVerticesCoordinates(&xyz_list);
+	//element->FindParam(&FSreconditioning,StressbalanceFSreconditioningEnum);
+	Input* vx_input=element->GetInput(VxEnum);     _assert_(vx_input);
+	Input* vy_input=element->GetInput(VyEnum);     _assert_(vy_input);
+	Input* vz_input = NULL;
+	if(dim==3){vz_input=element->GetInput(VzEnum); _assert_(vz_input);}
+
+
+	/* Start  looping on the number of gaussian points: */
+	Gauss* gauss = element->NewGauss(5);
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
+		gauss->GaussPoint(ig);
+
+		element->JacobianDeterminant(&Jdet,xyz_list,gauss);
+		element->NodalFunctionsPressure(pbasis,gauss);
+		element->material->ViscosityFS(&viscosity,dim,xyz_list,gauss,vx_input,vy_input,vz_input);
+
+
+		if(dim==3 || dim==2){
+			/*Pressure mass matrix*/
+			for(int k=0;k<pnumnodes;k++){
+				for(int j=0;j<pnumnodes;j++){
+					Ke->values[(dim*vnumnodes+k)*numdof+dim*vnumnodes+j] += gauss->weight*1./viscosity*Jdet*(pbasis[j]*pbasis[k]);
+				}
+			}
+		}else{
+			_error_("STOP");
+		}
+	}
+
+	/*Clean up and return*/
+	delete gauss;
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(pbasis);
+	return Ke;
+}/*}}}*/
+
 ElementMatrix* StressbalanceAnalysis::CreateKMatrixFSViscousLA(Element* element){/*{{{*/
 
Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.h	(revision 23389)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.h	(revision 23394)
@@ -75,4 +75,5 @@
 		ElementMatrix* CreateKMatrixFSViscousXTH(Element* element);
 		ElementMatrix* CreatePressureMassMatrix(Element* element);
+		ElementMatrix* CreateSchurPrecondMatrix(Element* element);
 		ElementVector* CreatePVectorFS(Element* element);
 		ElementVector* CreatePVectorFSFriction(Element* element);
Index: issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 23394)
@@ -111,6 +111,31 @@
 	}
 	iomodel->FetchDataToInput(elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum);
-	iomodel->FetchDataToInput(elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum,0.);
 	//iomodel->FetchDataToInput(elements,"md.smb.mass_balance",SmbMassBalanceEnum);
+
+
+	/*Add basal forcings to compute melt rate*/
+	int basalforcing_model;
+	iomodel->FindConstant(&basalforcing_model,"md.basalforcings.model");
+	switch(basalforcing_model){
+		case FloatingMeltRateEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum);
+			break;
+		case LinearFloatingMeltRateEnum:
+			break;
+		case MismipFloatingMeltRateEnum:
+			break;
+		case MantlePlumeGeothermalFluxEnum:
+			break;
+		case SpatialLinearFloatingMeltRateEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_melting_rate",BasalforcingsDeepwaterMeltingRateEnum);
+			iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_elevation",BasalforcingsDeepwaterElevationEnum);
+			iomodel->FetchDataToInput(elements,"md.basalforcings.upperwater_elevation",BasalforcingsUpperwaterElevationEnum);
+			break;
+		case BasalforcingsPicoEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.basin_id",BasalforcingsPicoBasinIdEnum);
+			break;
+		default:
+			_error_("Basal forcing model "<<EnumToStringx(basalforcing_model)<<" not supported yet");
+	}
 	iomodel->FetchDataToInput(elements,"md.initialization.vx",VxEnum,0.);
 	iomodel->FetchDataToInput(elements,"md.initialization.vy",VyEnum,0.);
Index: issm/trunk/src/c/analyses/ThermalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 23394)
@@ -33,6 +33,7 @@
 		int smb_model;
 		iomodel->FindConstant(&smb_model,"md.smb.model");
-		if(smb_model==SMBpddEnum) isdynamic=true;
-		if(smb_model==SMBd18opddEnum) isdynamic=true;
+		if(smb_model==SMBpddEnum)				isdynamic=true;
+		if(smb_model==SMBd18opddEnum)			isdynamic=true;
+		if(smb_model==SMBpddSicopolisEnum)  isdynamic=true;
 	}
 	else{
Index: issm/trunk/src/c/classes/Elements/Element.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/Elements/Element.cpp	(revision 23394)
@@ -653,4 +653,74 @@
 	xDelete<IssmDouble>(tmp);
 
+}
+/*}}}*/
+void       Element::SmbGradCompParameterization(void){/*{{{*/
+
+	/*Are we on the base? If not, return*/
+	if(!IsOnBase()) return;
+	int        numvertices = this->GetNumberOfVertices();
+
+	int        i;
+	IssmDouble accuref, runoffref; //reference values at given altitude
+	IssmDouble accualti, runoffalti; //reference altitudes
+	IssmDouble accugrad, runoffgrad; //gradients from reference altitude
+	IssmDouble rho_water, rho_ice;
+	IssmDouble time;
+
+	IssmDouble*		smb		 = xNew<IssmDouble>(numvertices);
+	IssmDouble*		surf	 = xNew<IssmDouble>(numvertices);
+	IssmDouble*		accu	 = xNew<IssmDouble>(numvertices);
+	IssmDouble*		runoff = xNew<IssmDouble>(numvertices);
+
+	/*Get material parameters :*/
+	rho_water=this->matpar->GetMaterialParameter(MaterialsRhoSeawaterEnum);
+	rho_ice=this->matpar->GetMaterialParameter(MaterialsRhoIceEnum);
+
+	/*Recover parameters*/
+	parameters->FindParam(&time,TimeEnum);
+	parameters->FindParam(&accualti,SmbAccualtiEnum);
+	parameters->FindParam(&accugrad,SmbAccugradEnum);
+	parameters->FindParam(&runoffalti,SmbRunoffaltiEnum);
+	parameters->FindParam(&runoffgrad,SmbRunoffgradEnum);
+
+	/*Recover reference values at current time*/
+	parameters->FindParam(&accuref,SmbAccurefEnum,time);
+	parameters->FindParam(&runoffref,SmbRunoffrefEnum,time);
+
+	/*Recover surface elevation*/
+	GetInputListOnVertices(&surf[0],SurfaceEnum);
+
+	/*Compute the temperature and precipitation*/
+	for(int iv=0;iv<numvertices;iv++){
+		accu[iv]=max(0.,(accuref+(surf[iv]-accualti)*accugrad));
+		runoff[iv]=max(0.,(runoffref+(surf[iv]-runoffalti)*runoffgrad));
+		smb[iv]=(accu[iv]-runoff[iv])*rho_ice/rho_water;
+	}
+	switch(this->ObjectEnum()){
+	case TriaEnum:
+		this->inputs->AddInput(new TriaInput(SmbMassBalanceEnum,&smb[0],P1Enum));
+		this->inputs->AddInput(new TriaInput(SmbRunoffEnum,&runoff[0],P1Enum));
+		break;
+	case PentaEnum:
+		this->inputs->AddInput(new PentaInput(SmbMassBalanceEnum,&smb[0],P1Enum));
+		this->inputs->AddInput(new PentaInput(SmbRunoffEnum,&runoff[0],P1Enum));
+		this->InputExtrude(SmbMassBalanceEnum,-1);
+		this->InputExtrude(SmbRunoffEnum,-1);
+		break;
+	case TetraEnum:
+		this->inputs->AddInput(new TetraInput(SmbMassBalanceEnum,&smb[0],P1Enum));
+		this->inputs->AddInput(new TetraInput(SmbRunoffEnum,&runoff[0],P1Enum));
+		this->InputExtrude(SmbMassBalanceEnum,-1);
+		this->InputExtrude(SmbRunoffEnum,-1);
+		break;
+	default: _error_("Not implemented yet");
+	}
+	/* this->AddInput(SmbMassBalanceEnum,smb,P1Enum); */
+	/* this->AddInput(SmbRunoffEnum,runoff,P1Enum); */
+	/*clean-up*/
+	xDelete<IssmDouble>(surf);
+	xDelete<IssmDouble>(accu);
+	xDelete<IssmDouble>(runoff);
+	xDelete<IssmDouble>(smb);
 }
 /*}}}*/
@@ -2561,4 +2631,169 @@
 }
 /*}}}*/
+void       Element::PositiveDegreeDaySicopolis(bool isfirnwarming){/*{{{*/
+
+	/* General FIXMEs: get Tmelting point, pddicefactor, pddsnowfactor, sigma from parameters/user input */
+
+	int  numvertices = this->GetNumberOfVertices();
+
+	int        i;
+	IssmDouble* smb=xNew<IssmDouble>(numvertices);		// surface mass balance
+	IssmDouble* melt=xNew<IssmDouble>(numvertices);		// melting comp. of surface mass balance
+	IssmDouble* accu=xNew<IssmDouble>(numvertices);		// accuumulation comp. of surface mass balance
+	IssmDouble* melt_star=xNew<IssmDouble>(numvertices);
+	IssmDouble* monthlytemperatures=xNew<IssmDouble>(12*numvertices);
+	IssmDouble* monthlyprec=xNew<IssmDouble>(12*numvertices);
+	IssmDouble* yearlytemperatures=xNew<IssmDouble>(numvertices); memset(yearlytemperatures, 0., numvertices*sizeof(IssmDouble));
+	IssmDouble* s=xNew<IssmDouble>(numvertices);			// actual surface height
+	IssmDouble* s0p=xNew<IssmDouble>(numvertices);		// reference elevation for precip.
+	IssmDouble* s0t=xNew<IssmDouble>(numvertices);		// reference elevation for temperature
+	IssmDouble* smbcorr=xNew<IssmDouble>(numvertices); // surface mass balance correction; will be added after pdd call
+	IssmDouble* p_ampl=xNew<IssmDouble>(numvertices);	// precip anomaly
+	IssmDouble* t_ampl=xNew<IssmDouble>(numvertices);	// remperature anomaly
+	IssmDouble rho_water,rho_ice,desfac,rlaps;
+	IssmDouble inv_twelve=1./12.;								//factor for monthly average
+	IssmDouble time,yts,time_yr;
+
+	/*Get material parameters :*/
+	rho_water=this->matpar->GetMaterialParameter(MaterialsRhoSeawaterEnum);
+	rho_ice=this->matpar->GetMaterialParameter(MaterialsRhoIceEnum);
+
+	/*Get parameters for height corrections*/
+	desfac=this->matpar->GetMaterialParameter(SmbDesfacEnum);
+	rlaps=this->matpar->GetMaterialParameter(SmbRlapsEnum);
+
+	/*Recover monthly temperatures and precipitation*/
+	Input*     input=this->inputs->GetInput(SmbMonthlytemperaturesEnum); _assert_(input);
+	Input*     input2=this->inputs->GetInput(SmbPrecipitationEnum); _assert_(input2);
+	/*Recover smb correction term */
+	Input*     input3=this->inputs->GetInput(SmbSmbCorrEnum); _assert_(input3);
+
+	/* Get time */
+	this->parameters->FindParam(&time,TimeEnum);
+	this->parameters->FindParam(&yts,ConstantsYtsEnum);
+	time_yr=floor(time/yts)*yts;
+
+	/* Set parameters for finrnwarming */
+	IssmDouble MU_0         = 9.7155; //Firn-warming correction, in (d*deg C)/(mm WE)
+	IssmDouble mu           = MU_0*(1000.0*86400.0)*(rho_ice/rho_water);   // (d*deg C)/(mm WE) --> (s*deg C)/(m IE)
+
+	/*loop over vertices: */
+	Gauss* gauss=this->NewGauss();
+	for(int month=0;month<12;month++){
+		for(int iv=0;iv<numvertices;iv++){
+			gauss->GaussVertex(iv);
+			input->GetInputValue(&monthlytemperatures[iv*12+month],gauss,(month+1)/12.*yts);
+			monthlytemperatures[iv*12+month]=monthlytemperatures[iv*12+month]-273.15; // conversion from Kelvin to celcius for PDD module
+			input2->GetInputValue(&monthlyprec[iv*12+month],gauss,(month+1)/12.*yts);
+			monthlyprec[iv*12+month]=monthlyprec[iv*12+month]*yts;
+		}
+	}
+
+	/*Recover info at the vertices: */
+	GetInputListOnVertices(&s[0],SurfaceEnum);
+	GetInputListOnVertices(&s0p[0],SmbS0pEnum);
+	GetInputListOnVertices(&s0t[0],SmbS0tEnum);
+	GetInputListOnVertices(&smbcorr[0],SmbSmbCorrEnum);
+	GetInputListOnVertices(&t_ampl[0],SmbTemperaturesAnomalyEnum);
+	GetInputListOnVertices(&p_ampl[0],SmbPrecipitationsAnomalyEnum);
+
+	/*measure the surface mass balance*/
+	for (int iv = 0; iv<numvertices; iv++){
+		smb[iv]=PddSurfaceMassBalanceSicopolis(&monthlytemperatures[iv*12], &monthlyprec[iv*12],
+					&melt[iv], &accu[iv], &melt_star[iv], &t_ampl[iv], &p_ampl[iv], yts, s[iv],
+					desfac, s0t[iv], s0p[iv],rlaps,rho_water,rho_ice);
+
+		/* make correction */
+		smb[iv] = smb[iv]+smbcorr[iv];
+		/*Get yearlytemperatures */
+		for(int month=0;month<12;month++) yearlytemperatures[iv]=yearlytemperatures[iv]+((monthlytemperatures[iv*12+month]+273.15)+t_ampl[iv])*inv_twelve; // Has to be in Kelvin
+
+		if(isfirnwarming){
+			if(melt_star[iv]>=melt[iv]){
+				yearlytemperatures[iv]= yearlytemperatures[iv]+mu*(melt_star[iv]-melt[iv]);
+			}
+			else{
+				yearlytemperatures[iv]= yearlytemperatures[iv];
+			}
+		}
+		if (yearlytemperatures[iv]>273.15) yearlytemperatures[iv]=273.15;
+	}
+
+	switch(this->ObjectEnum()){
+		case TriaEnum:
+			// this->inputs->AddInput(new TriaInput(TemperatureEnum,&yearlytemperatures[0],P1Enum));
+			this->inputs->AddInput(new TriaInput(TemperaturePDDEnum,&yearlytemperatures[0],P1Enum));
+			this->inputs->AddInput(new TriaInput(SmbMassBalanceEnum,&smb[0],P1Enum));
+			this->inputs->AddInput(new TriaInput(SmbAccumulationEnum,&accu[0],P1Enum));
+			this->inputs->AddInput(new TriaInput(SmbMeltEnum,&melt[0],P1Enum));
+			break;
+		case PentaEnum:
+			bool isthermal;
+			this->parameters->FindParam(&isthermal,TransientIsthermalEnum);
+			if(isthermal){
+				bool isenthalpy;
+				this->parameters->FindParam(&isenthalpy,ThermalIsenthalpyEnum);
+				if(IsOnSurface()){
+					/*Here, we want to change the BC of the thermal model, keep
+					 * the temperatures as they are for the base of the penta and
+					 * use yearlytemperatures for the top*/
+					GetInputListOnVertices(&s[0],TemperatureEnum);
+					yearlytemperatures[0] = s[0];
+					yearlytemperatures[1] = s[1];
+					yearlytemperatures[2] = s[2];
+					this->inputs->AddInput(new PentaInput(TemperatureEnum,&yearlytemperatures[0],P1Enum));
+					if(isenthalpy){
+						/*Convert that to enthalpy for the enthalpy model*/
+						IssmDouble enthalpy[6];
+						GetInputListOnVertices(&enthalpy[0],EnthalpyEnum);
+						ThermalToEnthalpy(&enthalpy[3],yearlytemperatures[3],0.,0.);
+						ThermalToEnthalpy(&enthalpy[4],yearlytemperatures[4],0.,0.);
+						ThermalToEnthalpy(&enthalpy[5],yearlytemperatures[5],0.,0.);
+						this->inputs->AddInput(new PentaInput(EnthalpyEnum,&enthalpy[0],P1Enum));
+					}
+				}
+			}
+			this->inputs->AddInput(new PentaInput(SmbMassBalanceEnum,&smb[0],P1Enum));
+			this->inputs->AddInput(new PentaInput(TemperaturePDDEnum,&yearlytemperatures[0],P1Enum));
+			this->inputs->AddInput(new PentaInput(SmbAccumulationEnum,&accu[0],P1Enum));
+			this->inputs->AddInput(new PentaInput(SmbMeltEnum,&melt[0],P1Enum));
+			this->InputExtrude(TemperaturePDDEnum,-1);
+			this->InputExtrude(SmbMassBalanceEnum,-1);
+			this->InputExtrude(SmbAccumulationEnum,-1);
+			this->InputExtrude(SmbMeltEnum,-1);
+			break;
+		case TetraEnum:
+			if(IsOnSurface()){
+				GetInputListOnVertices(&s[0],TemperatureEnum);
+				yearlytemperatures[0] = s[0];
+				yearlytemperatures[1] = s[1];
+				yearlytemperatures[2] = s[2];
+				this->inputs->AddInput(new TetraInput(TemperatureEnum,&yearlytemperatures[0],P1Enum));
+			}
+			this->inputs->AddInput(new TetraInput(SmbMassBalanceEnum,&smb[0],P1Enum));
+			this->inputs->AddInput(new TetraInput(TemperaturePDDEnum,&yearlytemperatures[0],P1Enum));
+			this->InputExtrude(TemperaturePDDEnum,-1);
+			this->InputExtrude(SmbMassBalanceEnum,-1);
+			break;
+		default: _error_("Not implemented yet");
+	}
+
+	/*clean-up*/
+	delete gauss;
+	xDelete<IssmDouble>(monthlytemperatures);
+	xDelete<IssmDouble>(monthlyprec);
+	xDelete<IssmDouble>(smb);
+	xDelete<IssmDouble>(melt);
+	xDelete<IssmDouble>(accu);
+	xDelete<IssmDouble>(yearlytemperatures);
+	xDelete<IssmDouble>(s);
+	xDelete<IssmDouble>(s0t);
+	xDelete<IssmDouble>(s0p);
+	xDelete<IssmDouble>(t_ampl);
+	xDelete<IssmDouble>(p_ampl);
+	xDelete<IssmDouble>(smbcorr);
+	xDelete<IssmDouble>(melt_star);
+}
+/*}}}*/
 IssmDouble Element::PureIceEnthalpy(IssmDouble pressure){/*{{{*/
 	return this->matpar->PureIceEnthalpy(pressure);
@@ -2568,6 +2803,6 @@
 	/*Some intputs need to be computed, even if they are already in inputs, they might not be up to date!*/
 	switch(output_enum){
-		case ViscousHeatingEnum: this->ViscousHeatingCreateInput(); break;
-		case StressMaxPrincipalEnum: this->StressMaxPrincipalCreateInput(); break;
+	case ViscousHeatingEnum: this->ViscousHeatingCreateInput(); break;
+	case StressMaxPrincipalEnum: this->StressMaxPrincipalCreateInput(); break;
 		case StressTensorxxEnum:
 		case StressTensorxyEnum:
@@ -2582,5 +2817,5 @@
 		case StrainRateyzEnum:
 		case StrainRatezzEnum:
-		case StrainRateeffectiveEnum: this->ComputeStrainRate(); break;
+	  case StrainRateeffectiveEnum: this->ComputeStrainRate(); break;
 		case DeviatoricStressxxEnum:
 		case DeviatoricStressxyEnum:
@@ -3133,5 +3368,8 @@
 		}
 
-		#ifndef _HAVE_ADOLC_ //we want to avoid the round operation at all cost. Not differentiable.
+		#if defined(_HAVE_AD_)
+		/*we want to avoid the round operation at all cost. Not differentiable.*/
+		_error_("not implemented yet");
+		#else
 		dMass = sumMass + sumR + sumW - sumP - sumEC - initMass - sumMassAdd;
 		dMass = round(dMass * 100.0)/100.0;
Index: issm/trunk/src/c/classes/Elements/Element.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.h	(revision 23389)
+++ issm/trunk/src/c/classes/Elements/Element.h	(revision 23394)
@@ -1,7 +1,7 @@
 /*!\file:  Element.h
  * \brief abstract class for Element object
- * This class is a place holder for the Tria and the Penta elements. 
+ * This class is a place holder for the Tria and the Penta elements.
  * It is derived from Element, so DataSets can contain them.
- */ 
+ */
 
 #ifndef _ELEMENT_H_
@@ -50,5 +50,5 @@
 		int  element_type;
 
-	public: 
+	public:
 		/*Constructors/Destructores*/
 		Element();
@@ -68,4 +68,5 @@
 		void               Delta18oParameterization(void);
 		void               Delta18opdParameterization(void);
+		void               SmbGradCompParameterization(void);
 		IssmDouble         Divergence(void);
 		void               dViscositydBFS(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vz_input);
@@ -130,14 +131,14 @@
 		void               InputUpdateFromConstant(int constant, int name);
 		void               InputUpdateFromConstant(bool constant, int name);
-		bool               IsFloating(); 
+		bool               IsFloating();
 		bool               IsIceInElement();
 		bool               IsLandInElement();
 		bool               IsWaterInElement();
-		void               LinearFloatingiceMeltingRate(); 
-		void               SpatialLinearFloatingiceMeltingRate(); 
-		void               MantlePlumeGeothermalFlux(); 
+		void               LinearFloatingiceMeltingRate();
+		void               SpatialLinearFloatingiceMeltingRate();
+		void               MantlePlumeGeothermalFlux();
 		void               MarshallElement(char** pmarshalled_data,int* pmarshalled_data_size, int marshall_direction,int numanalyses);
 		void               MigrateGroundingLine(IssmDouble* sheet_ungrounding);
-		void               MismipFloatingiceMeltingRate(); 
+		void               MismipFloatingiceMeltingRate();
 		void               MungsmtpParameterization(void);
 		ElementMatrix*     NewElementMatrix(int approximation_enum=NoneApproximationEnum);
@@ -145,4 +146,5 @@
 		ElementVector*     NewElementVector(int approximation_enum=NoneApproximationEnum);
 		void               PositiveDegreeDay(IssmDouble* pdds,IssmDouble* pds,IssmDouble signorm,bool ismungsm,bool issetpddfac);
+		void               PositiveDegreeDaySicopolis(bool isfirnwarming);
 		IssmDouble         PureIceEnthalpy(IssmDouble pressure);
 		void               ResultInterpolation(int* pinterpolation,int*nodesperelement,int* parray_size, int output_enum);
@@ -240,5 +242,5 @@
 		virtual bool       IsFaceOnBoundary(void)=0;
 		virtual bool       IsIcefront(void)=0;
-		virtual bool       IsNodeOnShelfFromFlags(IssmDouble* flags)=0; 
+		virtual bool       IsNodeOnShelfFromFlags(IssmDouble* flags)=0;
 		virtual bool       IsOnBase()=0;
 		virtual bool       IsOnSurface()=0;
@@ -330,5 +332,5 @@
 		virtual IssmDouble    OceanAverage(IssmDouble* Sg)=0;
 		virtual IssmDouble    OceanArea(void)=0;
-		virtual void          SealevelriseMomentOfInertia(IssmDouble* dI_list,IssmDouble* Sg_old,IssmDouble eartharea)=0; 
+		virtual void          SealevelriseMomentOfInertia(IssmDouble* dI_list,IssmDouble* Sg_old,IssmDouble eartharea)=0;
 		virtual void          SealevelriseEustatic(Vector<IssmDouble>* pSgi,IssmDouble* peustatic,IssmDouble* latitude,IssmDouble* longitude,IssmDouble* radius,IssmDouble oceanarea,IssmDouble eartharea)=0;
 		virtual void          SealevelriseNonEustatic(Vector<IssmDouble>* pSgo,IssmDouble* Sg_old,IssmDouble* latitude,IssmDouble* longitude,IssmDouble* radius,IssmDouble eartharea)=0;
Index: issm/trunk/src/c/classes/ExternalResults/GenericExternalResult.h
===================================================================
--- issm/trunk/src/c/classes/ExternalResults/GenericExternalResult.h	(revision 23389)
+++ issm/trunk/src/c/classes/ExternalResults/GenericExternalResult.h	(revision 23394)
@@ -622,5 +622,5 @@
 
 	/*Specific instantiations for IssmDouble*: */
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)  //We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization. 
+#if defined(_HAVE_AD_) && !defined(_WRAPPERS_)  //We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization. 
 template <> inline GenericExternalResult<IssmDouble*>::~GenericExternalResult(){ /*{{{*/
 	xDelete<char>(result_name);
@@ -709,5 +709,5 @@
 		return new GenericExternalResult<Vector<IssmPDouble>*>(this->id,StringToEnumx(this->result_name),this->value,this->step,this->time);
 	} /*}}}*/
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)  //We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization. 
+#if defined(_HAVE_AD_) && !defined(_WRAPPERS_)  //We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization. 
 	template <> inline void GenericExternalResult<Vector<IssmPDouble>*>::WriteData(FILE* fid,bool io_gather){ /*{{{*/
 
